using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Remoting;

namespace Klient
{
    class Program
    {
        static void Main(string[] args)
        {
            bool ensureSecurity = false;
            RemotingConfiguration.Configure("Klient.exe.config", ensureSecurity);
            // create proxy
            Interfaces.IDemo service = new Interfaces.DemoDummy();

            service.Memory = "tekst";
            Console.WriteLine("mem:" + service.Memory);
            service.Print("Hej p service");

            Interfaces.IDemo demoRem1 = service.GetNewRemote("Ny remote 1");
            Console.WriteLine("demoRem1 mem:" + demoRem1.Memory);
            demoRem1.Print("Hej p demoRem1");

            Interfaces.IDemo demoRem2 = demoRem1.GetNewRemote("Ny remote 2 ud fra remote 1");
            Console.WriteLine("demoRem2 mem:" + demoRem1.Memory);
            demoRem2.Print("Hej p demoRem2");


            Interfaces.IDemo demoMBVO = service.GetNewSerialized("Ny MBVO");
            Console.WriteLine("mem:" + demoMBVO.Memory);
            demoMBVO.Print("Hej p demoMBVO");

            Interfaces.IDemo demoRemLocal= demoMBVO.GetNewRemote("Ny remote ud fra MBVO");
            Console.WriteLine("demoRemLocal mem:" + demoRemLocal.Memory);
            demoRemLocal.Print("Hej p demoRemLocal");

            Console.WriteLine("------------------------------------------------------------------------------------");
            Console.WriteLine("Og nu det store eksperiment");
            Console.WriteLine("------------------------------------------------------------------------------------");

            Console.WriteLine("Kald af PrintOnObject p service med demoMBVO");
            service.PrintOnObject(demoMBVO);

            //Console.WriteLine("Kald af PrintOnObject p service med demoRem1");
            //service.PrintOnObject(demoRem1);

            //Console.WriteLine("Kald af PrintOnObject p service med demoRemLocal");
            //service.PrintOnObject(demoRemLocal);

            Console.WriteLine("Kald af PrintOnObject p demoMBVO med service");
            demoMBVO.PrintOnObject(service);

            Console.WriteLine("Kald af PrintOnObject p demoRemLocal med service");
            demoRemLocal.PrintOnObject(service);

            Console.ReadLine();
        }
    }
}
